/*
 * RelatedTags.java
 *
 *  Copyright (c) 2006, James G. Driscoll 
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

package org.jickr.example;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.util.List;
import org.jickr.Flickr;
import org.jickr.Tag;

/**
 *
 * @author driscoll
 */
public class RelatedTags {
    
    /**
     * Prints out all that tags considered "related" to the supplied tag.
     */
    public static void main(String[] args) throws Exception {
  
        // We'll read the API Key and Shared Secret from a file, since
        // We don't want to check in our keys.
        // Normally, we'd use the next block of code and hardcode the keys instead
        BufferedReader br = new BufferedReader(new FileReader("keys"));
        String apiKey = br.readLine();
        Flickr.setApiKey(apiKey);
        String sharedSecret = br.readLine();
        Flickr.setSharedSecret(sharedSecret);
        
        /*
        //  The Following block is the ususal one to include in programs.
        String apiKey = "notavalidapikey";
        Flickr.setApiKey(apiKey);
         
        String sharedSecret = "notavalidsharedsecret";
        Flickr.setSharedSecret(sharedSecret);
         */
        
        System.out.println("Enter a tag to search, and hit return (Example: prague):");
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        String search = in.readLine();

        List<String> tags = Tag.getRelated(search);
        
        System.out.println("Get all related tags for: "+search);
        
        for (String tag: tags) {
            System.out.println(tag);
        }
        if (tags.size() == 0) System.out.println("No related tags found.");
    }
    
}
