#!/usr/bin/perl
use strict;
use warnings;

my $photoDesc = "photos.txt";
my $photoDir = "D:/My Documents/My Pictures/Personal";
my $destDir = "D:/My Documents/My Projects/Personal/Atacama/descriptors/backup";

listRecursively($photoDir);

exit;

sub listRecursively {

    my($directory) = @_;
    my @files = (  );
    
    # Open the directory
    unless(opendir(DIRECTORY, $directory)) {
        print "Cannot open directory $directory!\n";
        exit;
    }
    
    # Read the directory, ignoring special entries "." and ".."
    @files = grep (!/^\.\.?$/, readdir(DIRECTORY)); 
    closedir(DIRECTORY);

    # Notice that we need to prepend the directory name!
    foreach my $file (@files) {
    
        # If the directory entry is a regular file
        if (-f "$directory/$file") {
            #if the file is a photo descriptor file
            if($file =~ /$photoDesc/) {
                #Source file for copying
                my $sourceFile = "$directory/$file";
                
                #Replace forslashed with backslashes for xcopy
                $sourceFile =~ s/\//\\/g;
                
                #Create destination file name from directory name
                my $destFile;
                ($destFile) = $directory =~ /$photoDir\/(.*)/;
                $destFile =~ s/\//-/ig;
                
                #Build xcopy command
                my $command = "xcopy \"$sourceFile\" \"$destDir\\$destFile\.txt\"";
                #print "Command: $command\n";
                
                #open pipe to xcopy command
                open XCOPY, "| $command" or die "Couldn't copy file '$directory/$file', $!\n";
                print XCOPY "f";
                close XCOPY;
            }
        # If the directory entry is a subdirectory
        }elsif( -d "$directory/$file") {

            # Here is the recursive call to this subroutine
            listRecursively("$directory/$file");
        }
    }
}