/*
 * Created on May 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.arellano.ramon.atacama.descriptor;

import java.io.File;
import java.util.Vector;

import com.arellano.ramon.atacama.entity.Album;
import com.arellano.ramon.atacama.entity.Photo;
import com.arellano.ramon.atacama.system.AtacamaException;
import com.arellano.ramon.atacama.system.Tester;

/**
 * @author ramon.arellano
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DescriptorTester extends Tester {

	public void testDescriptorParser() {
		DescriptorParser descParser = new DescriptorParser();
		descParser.parseGalleryToXml();
		
	}

	public void testPhotoDescriptorsReader() throws AtacamaException {
		DescriptorReader descReader  = new DescriptorReader();
		descReader.readPhotoDescriptors(testPhotosPath);		
	}

	public void testAlbumDescriptorReader() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
		
		DescriptorReader descReader  = new DescriptorReader();
		
		String albumDescFilePath =  theConfig.getString("descriptor.file.text.album");
		Vector albums = descReader.readAlbumDescriptor(albumDescFilePath);
	
		Album album = null;
		for(int index = 0; index < albums.size(); index++) {
			album = (Album) albums.elementAt(index);
			appendResult(resultString, album.toString());
		}
		
		writeResultFile(resultString, false);
		validateTest();				
	}
	
	public void testDescriptorGenerator() throws AtacamaException {
		DescriptorGenerator descGenerator = new DescriptorGenerator();
		descGenerator.generate(true);
	}
	
	public void testPassInfoToNewDescriptor() throws AtacamaException {
		
		StringBuffer resultString = new StringBuffer();
		DescriptorReader descReader  = new DescriptorReader();

		//First copy the test descriptor
		String descriptorFileName =  theConfig.getString("descriptor.file.text.photo");
		String[] testDescriptorString = theFileManager.readTextFile(new File(testPhotoDirectory2, "photos_test.txt"));
		theFileManager.writeTextFile(new File(testPhotoDirectory2, descriptorFileName), testDescriptorString, true);

		Vector descPhotos = descReader.readPhotoDescriptor(testPhotoDirectory2, true);

		DescriptorGenerator descGenerator = new DescriptorGenerator();
		Vector dirPhotos = descGenerator.readPhotoDirectory(testPhotoDirectory2);
		
		String result = new Boolean(descGenerator.passInfoToNewDesc(descPhotos, dirPhotos)).toString();
		appendResult(resultString, result);

		Photo photo = null;
		for(int index = 0; index < dirPhotos.size(); index++) {
			photo = (Photo) dirPhotos.elementAt(index);
			appendResult(resultString, photo.toString());
		}
		
		writeResultFile(resultString, false);
		validateTest();		
	}
	
	public void testDescriptorCompare() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
		DescriptorReader descReader  = new DescriptorReader();
		Vector descPhotos = descReader.readPhotoDescriptor(testPhotoDirectory, true);

		DescriptorGenerator descGenerator = new DescriptorGenerator();
		Vector dirPhotos = descGenerator.readPhotoDirectory(testPhotoDirectory);

		String result = new Boolean(descReader.validatePhotoVector(dirPhotos, descPhotos, true)).toString();
		appendResult(resultString, result);

		Photo anyPhoto = (Photo) descPhotos.elementAt(5);
		anyPhoto.setPhotoName("anything");
		result = new Boolean(descReader.validatePhotoVector(dirPhotos, descPhotos, false)).toString();
		appendResult(resultString, result);

		writeResultFile(resultString, false);		
		validateTest();
	}
	
	public void testPhotoDescriptorReader() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
		
		DescriptorReader descReader  = new DescriptorReader();
		
		Vector descPhotos = descReader.readPhotoDescriptor(testPhotoDirectory, true);
		
		Photo photo = null;
		for(int index = 0; index < descPhotos.size(); index++) {
			photo = (Photo) descPhotos.elementAt(index);
			appendResult(resultString, photo.toString());
		}
		
		writeResultFile(resultString, false);		
		validateTest();
	}
		
	public void testPhotoDirectoryReader() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
		DescriptorGenerator descGen = new DescriptorGenerator();
		Vector dirPhotos = descGen.readPhotoDirectory(testPhotoDirectory);

		Photo photo = null;
		for(int index = 0; index < dirPhotos.size(); index++) {
			photo = (Photo) dirPhotos.elementAt(index);
			appendResult(resultString, photo.toString());
		}

		writeResultFile(resultString, false);
		validateTest();
	}
	
}
