/*
 * Created on May 28, 2004
 *
 */
package com.arellano.ramon.atacama.entity;

import java.util.Vector;

import com.arellano.ramon.atacama.system.AtacamaException;
import com.arellano.ramon.atacama.system.Tester;

public class EntityTester extends Tester {
	public void testEntities() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
		//Create and compare photos
		int numOfPhotos = 3;
		String[] photoDescriptorLines = new String[numOfPhotos];
		photoDescriptorLines[0] = "navn1;ja;galleri;strrelse;false;ja det var det ja .... huff og huff";
		photoDescriptorLines[1] = "navn2;ja;galleri;strrelse;false;ja det var det ja .... huff og huff";
		photoDescriptorLines[2] = "navn2;ja;galleri;strrelse;false;ja det var det ja .... huff og huff";
		Vector photos = new Vector();
		try {
			//Create
			Photo photo = null;
			for(int index = 0;index<numOfPhotos;index++) {
				photo = new Photo(photoDescriptorLines[index]);
				photos.add(photo);
				appendResult(resultString, "Photo " + index + ": '" + photo.toString() + "'");
			}
		} catch(Exception exception) { 
			theLogger.logError("Could not parse descriptor line: " + exception.toString());
		}
		
		//Compare
		for(int index = 0;index<numOfPhotos-1;index++) {
			Photo photo1 = (Photo) photos.elementAt(index);
			Photo photo2 = (Photo) photos.elementAt(index+1);
			appendResult(
				resultString, 
				"Photo "
				+ (index + 1)
				+  " equals "
				+ (index + 2) 
				+ ": "
				+ photo1.equals(photo2));
		}
		
		//Create and compare albums
		int numOfAlbums = 3;
		String[] albumDescriptorLines = new String[numOfAlbums];
		albumDescriptorLines[0] = "album2;ja;nei;2004;Chile;November;Det var her og der";
		albumDescriptorLines[1] = "album2;ja;nei;2004;Chile;November;Det var her og der";
		albumDescriptorLines[2] = "album2;ja;nei;2004;Chile;November;Det var her og der";
		Album[] albums = new Album[numOfAlbums];
		try {
			for(int index = 0;index<numOfAlbums;index++) {
				albums[index] = new Album(albumDescriptorLines[index]);
				albums[index].setPhotos(new Vector(photos));
				appendResult(resultString, "Album " + index + ": '"  + albums[index].toString() + "'");
				
			}
		} catch(Exception exception) { 
			theLogger.logError("Could not parse descriptor line: " + exception.toString());
		}
		
		//Compare
		for(int index = 0;index<numOfAlbums-1;index++) {
			appendResult(
				resultString, 
				"Album "
				+ (index + 1)
				+  " equals "
				+ (index + 2) 
				+ ": "
				+ albums[index].equals(albums[index+1]));
		}
		
		writeResultFile(resultString, false);
		validateTest();
	}
}
