/*
 * Created on May 28, 2004
 *
*/
package com.arellano.ramon.atacama.file;

import java.io.File;

import com.arellano.ramon.atacama.system.AtacamaException;
import com.arellano.ramon.atacama.system.Tester;

public class FileTester extends Tester {
	
	public void testDirSearch() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
		String[] listOfDirs = theFileManager.listSubdirs(new File(testPhotosPath));
		
		for(int index = 0;index < listOfDirs.length;index++) {
			appendResult(resultString, listOfDirs[index]);
		}
	
		writeResultFile(resultString, false);
		validateTest();
	}
	
	public void testFileReader() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
	
		String fileName = theConfig.getString("descriptor.file.text.photo");
		String[] textFile = theFileManager.readTextFile(new File(testPhotoDirectory, fileName));
		for(int index = 0; index < textFile.length; index++) {
			appendResult(resultString, textFile[index]);
		}
	
		writeResultFile(resultString, false);
		validateTest();
	}
	
	public void testFileSearch() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
		String path = testPhotoDirectory;
		String extensions = theConfig.getString("descriptor.filetypes");
		String[] listOfFiles = theFileManager.findFiles(new File(path), extensions, false);
		
		for(int index = 0;index < listOfFiles.length;index++) {
			appendResult(resultString, listOfFiles[index]);
		}
	
		writeResultFile(resultString, false);
		validateTest();
	}

	public void testFileSubdirSearch() throws AtacamaException {
		StringBuffer resultString = new StringBuffer();
		String path = testPhotosPath;
		String pattern = theConfig.getString("descriptor.file.text.photo");
		String[] listOfFiles = theFileManager.findFiles(new File(path), pattern, true);	
		
		for(int index = 0;index < listOfFiles.length;index++) {
			appendResult(resultString, listOfFiles[index]);
		}
	
		writeResultFile(resultString, false);
		validateTest();
	}
	
}
