/*
 * Created on 08.jun.04
 *
 */
package com.arellano.ramon.atacama.gui;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionListener;

/**
 * @author ramon.arellano
 *
 * A panel with a label describing a file, a label with the path to the file
 * and a button for choosing another file. Used for choosing album descriptors
 * and other files.
 */
public class FileSelectionPanel extends Panel {
	public FileSelectionPanel(
		String title,
		Label pathLabel,
		String buttonAction,
		ActionListener actionListener) {
		//Create components for selection panel
		Label titleLabel = new Label(title);
		titleLabel.setFont(new Font("Arial", Font.BOLD, 12));

		//Create album directory label for album directory selection panel
		pathLabel.setText(
			Controller.getInstance().getSizedString(pathLabel.getText(), 63));
		pathLabel.setFont(new Font("Courier", Font.PLAIN, 11));

		//Create album directory selection panel and add components
		Panel nameLabelPanel = new Panel();
		nameLabelPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		nameLabelPanel.add(titleLabel);
		nameLabelPanel.add(pathLabel);

		//Create change directory button for album directory selection panel
		Button changeFileButton = new Button(buttonAction);
		changeFileButton.setFont(new Font("Arial", Font.BOLD, 12));
		changeFileButton.addActionListener(actionListener);

		//Create album directory selection panel and add components
		Panel changeButtonPanel = new Panel();
		changeButtonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		changeButtonPanel.add(changeFileButton);

		//Add to this panel
		setLayout(new BorderLayout());
		add(nameLabelPanel, "Center");
		add(changeButtonPanel, "East");
	}
}
