
/*
 * FlickrRuntimeException.java
 *
 *  Copyright (c) 2006, James G. Driscoll 
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */

package org.jickr;


/**
 * Generic Runtime exception thrown by Jickr.  As with all Runtime exceptions,
 * the expecation is that if you see this error, then you probably did something
 * wrong.  <code>FlickrException</code> is thrown instead if the error was outside of your 
 * control.
 *
 * @see FlickrException
 * @author Jim Driscoll <a href="mailto:jgd@jamesgdriscoll.com">jgd@jamesgdriscoll.com</a>
 */
public class FlickrRuntimeException extends java.lang.RuntimeException {
    
    /**
     * Creates a new instance of <code>FlickrRuntimeException</code> without detail message.
     */
    public FlickrRuntimeException(String msg) {
        super(msg);
    }
    
    /**
     * Constructs an instance of <code>FlickrRuntimeException</code> with the specified detail message.
     * @param msg the detail message.
     */
    public FlickrRuntimeException(String msg, Throwable cause) {
        super(msg,cause);
    }
}
